import { GraphQLEnumValue } from "graphql";
import { StringKeyOf } from "../../../..";
import { GQLElement } from "../../../../classes/GQLElement";
export declare class EnumValue<NameType = string, ExtensionsType = any> extends GQLElement<any, any, ExtensionsType> {
    protected _name: NameType & string;
    private _value;
    private _deprecationReason;
    get name(): NameType & string;
    get value(): any;
    /**
     * The teh value deprecation reason
     * @param deprecationReason The deprecation reason
     */
    setDeprecationReason(deprecationReason: string): void;
    /**
     * Set the value
     * @param value The value
     */
    setValue(value: any): void;
    /**
     * Create a new EnumValue
     * @param name The value name
     * @param value The value
     */
    static create<NameType = any>(name: StringKeyOf<NameType>, value: any): EnumValue<StringKeyOf<NameType>>;
    protected constructor(name: string, value: any);
    build(): GraphQLEnumValue;
}
