import { ClassType, ClassToInterface } from "..";
export declare type PossibleType = string | number | symbol | Object | Boolean | BigInt | Function | PossibleType[];
export interface Description {
    property: string;
    type: PossibleType;
}
export declare class ClassDescriptor {
    static describe<T extends ClassType<any>, DescriptionValue>(classType: T, description: ClassToInterface<T>): any;
    static describe<T extends ClassType<any>>(classType: T): any;
    static convertTypeOfToType(item: any): PossibleType;
    static instanceOf<T>(item: T, ...possibleIntances: Function[]): boolean;
    static doExtends<TClassType extends ClassType>(classType: TClassType, extension: Function): boolean;
}
